# GPUToolbox.jl

*Common utilities shared between the various Julia GPU backends.*

| **Build Status**                                               | **Coverage**                    |
|:--------------------------------------------------------------:|:-------------------------------:|
| [![][gha-img]][gha-url] [![PkgEval][pkgeval-img]][pkgeval-url] | [![][codecov-img]][codecov-url] |

[gha-img]: https://github.com/JuliaGPU/GPUToolbox.jl/actions/workflows/Test.yml/badge.svg?branch=main
[gha-url]: https://github.com/JuliaGPU/GPUToolbox.jl/actions

[pkgeval-img]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/G/GPUToolbox.svg
[pkgeval-url]: https://juliaci.github.io/NanosoldierReports/pkgeval_badges/G/GPUToolbox.html

[codecov-img]: https://codecov.io/gh/JuliaGPU/GPUToolbox.jl/branch/main/graph/badge.svg
[codecov-url]: https://codecov.io/gh/JuliaGPU/GPUToolbox.jl

## Functionality

This package currently exports the following:
- `SimpleVersion`: a GPU-compatible version number
- `@sv_str`: constructs a SimpleVersion from a string
- `@checked`: Add to a function definition to generate an unchecked and a checked version.
- `@debug_ccall`: like `ccall` but prints the ccall, its arguments, and its return value
- `@gcsafe_ccall`: like `@ccall` but marking it safe for the GC to run.
-  Suffix literals like `1i8` (`i8`, `i16`, `i32`, `u8`, `u16`, `u32`) for constructing literals of a certain type.

For more details on a specific symbol, check out its docstring in the Julia REPL.

export i8, i16, i32, u8, u16, u32
# helper type for writing smaller than Int64 literals

"""
    Literal{T}

Construct an object that can be used to convert literals to other types.
One can use the object in suffix form `1*i8` or `1i8` to perform the conversion.

## Exported constants
- `i8`: Convert to `Int8`
- `i16`: Convert to `Int16`
- `i32`: Convert to `Int32`
- `u8`: Convert to `UInt8`
- `u16`: Convert to `UInt16`
- `u32`: Convert to `UInt32`
"""
struct Literal{T} end
Base.:(*)(x::Number, ::Type{Literal{T}}) where {T} = T(x)

const i8 = Literal{Int8}
const i16 = Literal{Int16}
const i32 = Literal{Int32}
const u8 = Literal{UInt8}
const u16 = Literal{UInt16}
const u32 = Literal{UInt32}

using GPUToolbox
using Documenter
import Documenter.Remotes: GitHub

DocMeta.setdocmeta!(GPUToolbox, :DocTestSetup, :(using GPUToolbox); recursive = true)

makedocs(;
    modules = [GPUToolbox],
    authors = "",
    repo = GitHub("JuliaGPU", "GPUToolbox.jl"),
    sitename = "GPUToolbox.jl",
    format = Documenter.HTML(;
        prettyurls = get(ENV, "CI", "false") == "true",
        canonical = "https://juliagpu.com/GPUToolbox.jl",
        mathengine = MathJax3(),
    ),
    pages = [
        "Home" => "index.md",
    ],
    doctest = true,
    linkcheck = true,
)

deploydocs(;
    repo = "github.com/JuliaGPU/GPUToolbox.jl.git",
    devbranch = "main",
    push_preview = true,
)

export SimpleVersion, @sv_str

"""
    SimpleVersion(major, [minor])
    SimpleVersion(v::AbstractString)

A GPU-compatible version number.
"""
struct SimpleVersion
    major::UInt32
    minor::UInt32

    SimpleVersion(major, minor = 0) = new(major, minor)
end

function Base.tryparse(::Type{SimpleVersion}, v::AbstractString)
    parts = split(v, ".")
    1 <= length(parts) <= 2 || return nothing

    int_parts = map(parts) do part
        tryparse(Int, part)
    end
    any(isnothing, int_parts) && return nothing

    return SimpleVersion(int_parts...)
end

function Base.parse(::Type{SimpleVersion}, v::AbstractString)
    ver = tryparse(SimpleVersion, v)
    ver === nothing && throw(ArgumentError("invalid SimpleVersion string: '$v'"))
    return ver
end

SimpleVersion(v::AbstractString) = parse(SimpleVersion, v)

@inline function Base.isless(a::SimpleVersion, b::SimpleVersion)
    (a.major < b.major) && return true
    (a.major > b.major) && return false
    (a.minor < b.minor) && return true
    (a.minor > b.minor) && return false
    return false
end

"""
    sv"str"

Construct a `SimpleVersion` from `str`.
"""
macro sv_str(str)
    return SimpleVersion(str)
end

export @memoize

@static if VERSION >= v"1.11"
    const _SlotArray{T} = AtomicMemory{Union{Nothing,Some{T}}}
else
    const _SlotArray{T} = Vector{Union{Nothing,Some{T}}}
end

mutable struct FixedMemo{T}
    @atomic data::Union{Nothing,_SlotArray{T}}
    const lock::ReentrantLock
end
FixedMemo{T}() where {T} = FixedMemo{T}(nothing, ReentrantLock())

mutable struct DictMemo{K,V}
    dict::Dict{K,V}
    const lock::ReentrantLock
end
DictMemo{K,V}() where {K,V} = DictMemo{K,V}(Dict{K,V}(), ReentrantLock())

@inline memoize_should_publish() = !generating_output() || HAS_FIELD_REPLACE

Base.@propagate_inbounds @inline function memoize_slot_load(data::_SlotArray{T}, key) where {T}
    @boundscheck checkbounds(data, key)
    @static if VERSION >= v"1.12"
        return @inbounds @atomic :acquire data[key]
    elseif VERSION >= v"1.11"
        # the `@atomic` macro only gained `AtomicMemory` element access on 1.12;
        # use the `Core.memoryref*` intrinsics as the bridge on 1.11.
        ref = Core.memoryrefnew(Core.memoryref(data), Int(key), false)
        return Core.memoryrefget(ref, :acquire, false)
    else
        return @inbounds data[key]
    end
end

Base.@propagate_inbounds @inline function memoize_slot_store!(
    data::_SlotArray{T}, key, val::Union{Nothing,Some{T}}
) where {T}
    @boundscheck checkbounds(data, key)
    @static if VERSION >= v"1.12"
        @inbounds @atomic :release data[key] = val
    elseif VERSION >= v"1.11"
        ref = Core.memoryrefnew(Core.memoryref(data), Int(key), false)
        Core.memoryrefset!(ref, val, :release, false)
    else
        @inbounds data[key] = val
    end
    return val
end

@inline memoize_grow_len(oldlen::Int, key::Int) = max(key, 2 * oldlen)

function memoize_grow_slots(::Type{T}, old::Union{Nothing,_SlotArray{T}}, newlen) where {T}
    newlen = Int(newlen)
    data = _SlotArray{T}(undef, newlen)
    n = old === nothing ? 0 : length(old)
    @inbounds for i in 1:n
        memoize_slot_store!(data, i, memoize_slot_load(old, i))
    end
    @inbounds for i in (n + 1):newlen
        memoize_slot_store!(data, i, nothing)
    end
    return data
end

@noinline function memoize_grow_slow!(constructor, m::FixedMemo{T}, key) where {T}
    key = Int(key)
    key >= 1 || throw(BoundsError())
    memoize_should_publish() || return constructor()::T

    @lock m.lock begin
        data = @atomic :acquire m.data
        if data === nothing
            data = memoize_grow_slots(T, nothing, memoize_grow_len(0, key))
            generating_output() && wipe_on_serialize!(m, :data, nothing)
            @atomic :release m.data = data
        elseif key > length(data)
            oldlen = length(data)
            newlen = memoize_grow_len(oldlen, key)
            @static if VERSION >= v"1.11"
                data = memoize_grow_slots(T, data, newlen)
                generating_output() && wipe_on_serialize!(m, :data, nothing)
                @atomic :release m.data = data
            else
                generating_output() && wipe_on_serialize!(m, :data, nothing)
                resize!(data, newlen)
                @inbounds for i in (oldlen + 1):newlen
                    memoize_slot_store!(data, i, nothing)
                end
            end
        end

        cached = memoize_slot_load(data, key)
        cached !== nothing && return Base.something(cached)::T

        val = constructor()::T
        generating_output() && wipe_on_serialize!(m, :data, nothing)
        memoize_slot_store!(data, key, Some{T}(val))
        return val
    end
end

"""
    @memoize [key=expr::K | index=expr] begin
        # expensive computation
    end::T

Low-level, no-frills memoization macro that stores values in a process-local, typed cache.
The types of the caches are derived from the syntactical type assertions.
All return values, including `nothing`, are memoized correctly.

With no leading argument, a single value is memoized. Use `key=expr::K` for dictionary
memoization keyed by values of type `K`. Use `index=expr` for array-backed memoization
with small, dense, positive integer indices; sparse or large keys should use dictionary
mode instead. Index mode grows the backing array on demand. On Julia 1.11+, index-mode
slots use atomic per-element access. Atomic slot access is lock-free for
pointer-representable values; other values may use Julia's internal per-element atomic
fallback.
"""
macro memoize(ex...)
    code = ex[end]
    args = ex[1:end-1]

    # decode the code body
    Meta.isexpr(code, :(::)) ||
        throw(ArgumentError("@memoize requires the body to end in `end::T`"))
    rettyp = code.args[2]
    code = code.args[1]

    # decode the arguments
    mode = :single
    key = nothing
    index = nothing
    for arg in args
        if !Meta.isexpr(arg, :(=))
            throw(ArgumentError(
                "@memoize positional keys are no longer supported; use `key=expr::K` " *
                "for dictionary mode or `index=expr` for array mode",
            ))
        end

        name, val = arg.args
        if name === :key
            mode === :single ||
                throw(ArgumentError("@memoize accepts only one of `key=` or `index=`"))
            Meta.isexpr(val, :(::)) ||
                throw(ArgumentError("@memoize `key=` requires a type assertion, e.g. `key=x::Int`"))
            key = (val=val.args[1], typ=val.args[2])
            mode = :dict
        elseif name === :index
            mode === :single ||
                throw(ArgumentError("@memoize accepts only one of `key=` or `index=`"))
            Meta.isexpr(val, :(::)) &&
                throw(ArgumentError("@memoize `index=` does not take a type assertion; use `index=x`"))
            index = val
            mode = :array
        elseif name === :maxlen
            throw(ArgumentError(
                "@memoize `maxlen=` is no longer supported; use `index=expr` for " *
                "dense integer indices or `key=expr::K` for dictionary mode",
            ))
        else
            throw(ArgumentError(
                "@memoize unknown option `$name`; expected `key=expr::K` or `index=expr`",
            ))
        end
    end

    @gensym global_cache
    mod = @__MODULE__
    lazy_ty = GlobalRef(mod, :LazyInitialized)
    fixed_ty = GlobalRef(mod, :FixedMemo)
    dict_ty = GlobalRef(mod, :DictMemo)
    slot_load = GlobalRef(mod, :memoize_slot_load)
    grow_slow = GlobalRef(mod, :memoize_grow_slow!)
    should_publish = GlobalRef(mod, :memoize_should_publish)
    generating = GlobalRef(mod, :generating_output)
    wipe = GlobalRef(mod, :wipe_on_serialize!)

    rettyp_esc = esc(rettyp)
    code_esc = esc(code)

    if mode === :single
        @eval __module__ begin
            const $global_cache = $lazy_ty{$rettyp}()
        end

        ex = quote
            let cache = $(esc(global_cache))
                val = @atomic :acquire cache.value
                if val !== nothing
                    Base.something(val)::$rettyp_esc
                else
                    Base.get!(cache) do
                        $code_esc::$rettyp_esc
                    end
                end
            end
        end
    elseif mode === :array
        @eval __module__ begin
            const $global_cache = $fixed_ty{$rettyp}()
        end

        index_esc = esc(index)
        ex = quote
            let cache = $(esc(global_cache)), key = Int($index_esc)
                @static if VERSION >= v"1.11"
                    data = @atomic :acquire cache.data
                    if data !== nothing && 1 <= key <= length(data)
                        # bounds already checked above; skip the redundant check
                        cached_value = @inbounds $slot_load(data, key)
                        if cached_value !== nothing
                            Base.something(cached_value)::$rettyp_esc
                        else
                            $grow_slow(cache, key) do
                                $code_esc::$rettyp_esc
                            end
                        end
                    else
                        $grow_slow(cache, key) do
                            $code_esc::$rettyp_esc
                        end
                    end
                else
                    $grow_slow(cache, key) do
                        $code_esc::$rettyp_esc
                    end
                end
            end
        end
    elseif mode === :dict
        @eval __module__ begin
            const $global_cache = $dict_ty{$(key.typ),$rettyp}()
        end

        key_val_esc = esc(key.val)
        ex = quote
            let cache = $(esc(global_cache)), key = $key_val_esc
                @lock cache.lock begin
                    dict = cache.dict
                    if haskey(dict, key)
                        dict[key]::$rettyp_esc
                    else
                        new_value = $code_esc::$rettyp_esc
                        if $should_publish()
                            $generating() && $wipe(cache, :dict, empty(dict))
                            dict[key] = new_value
                        end
                        new_value
                    end
                end
            end
        end
    end

    quote
        $ex
    end
end

module GPUToolbox

using LLVM
using LLVM.Interop

include("simpleversion.jl")
include("ccalls.jl")
include("literals.jl")
include("enum.jl")
include("threading.jl")
include("memoization.jl")

end # module GPUToolbox

# utilities for calling foreign functionality more conveniently

export @checked, @debug_ccall, @gcsafe_ccall


## function wrapper for checking the return value of a function

"""
    @checked function foo(...)
        rv = ...
        return rv
    end

Macro for wrapping a function definition returning a status code. Two versions of the
function will be generated: `foo`, with the function execution wrapped by an invocation of
the `check` function (to be implemented by the caller of this macro), and `unchecked_foo`
where no such invocation is present and the status code is returned to the caller.
"""
macro checked(ex)
    # parse the function definition
    @assert Meta.isexpr(ex, :function)
    sig = ex.args[1]
    @assert Meta.isexpr(sig, :call)
    body = ex.args[2]
    @assert Meta.isexpr(body, :block)

    # make sure these functions are inlined
    pushfirst!(body.args, Expr(:meta, :inline))

    # generate a "safe" version that performs a check
    safe_body = quote
        @inline
        check() do
            $body
        end
    end
    safe_sig = Expr(:call, sig.args[1], sig.args[2:end]...)
    safe_def = Expr(:function, safe_sig, safe_body)

    # generate a "unchecked" version that returns the error code instead
    unchecked_sig = Expr(:call, Symbol("unchecked_", sig.args[1]), sig.args[2:end]...)
    unchecked_def = Expr(:function, unchecked_sig, body)

    return esc(:($safe_def, $unchecked_def))
end

## version of ccall that prints the ccall, its arguments and its return value
"""
    @debug_ccall ...

A version of `ccall`` that prints the ccall, its arguments, and its return value.
"""
macro debug_ccall(ex)
    @assert Meta.isexpr(ex, :(::))
    call, ret = ex.args
    @assert Meta.isexpr(call, :call)
    target, argexprs... = call.args
    args = map(argexprs) do argexpr
        @assert Meta.isexpr(argexpr, :(::))
        argexpr.args[1]
    end

    ex = Expr(:macrocall, Symbol("@ccall"), __source__, ex)

    # avoid task switches
    io = :(Core.stdout)

    return quote
        print($io, $(string(target)), '(')
        for (i, arg) in enumerate(($(map(esc, args)...),))
            i > 1 && print($io, ", ")
            render_arg($io, arg)
        end
        print($io, ')')

        rv = $(esc(ex))

        println($io, " = ", rv)
        for (i, arg) in enumerate(($(map(esc, args)...),))
            if arg isa Base.RefValue
                println($io, " $i: ", arg[])
            end
        end
        rv
    end
end

render_arg(io, arg) = print(io, arg)
render_arg(io, arg::AbstractArray) = summary(io, arg)
render_arg(io, arg::Base.RefValue{T}) where {T} = print(io, "Ref{", T, "}")


## version of ccall that calls jl_gc_safe_enter|leave around the inner ccall
# note that this is generally only safe with functions that do not call back into Julia.
# when callbacks occur, the code should ensure the GC is not running by wrapping the code
# in the `@gcunsafe` macro

const HAS_CCALL_GCSAFE = VERSION >= v"1.13.0-DEV.70" || v"1.12-DEV.2029" <= VERSION < v"1.13-"

"""
    @gcsafe_ccall ...

Call a foreign function just like [`@ccall`](https://docs.julialang.org/en/v1/base/c/#Base.@ccall), but marking it safe for the GC to run. This is
useful for functions that may block, so that the GC isn't blocked from running, but may also
be required to prevent deadlocks (see JuliaGPU/CUDA.jl#2261).

Note that this is generally only safe with non-Julia C functions that do not call back into
the Julia directly.
"""
macro gcsafe_ccall end

if HAS_CCALL_GCSAFE
    macro gcsafe_ccall(expr)
        exprs = Any[:(gc_safe = true), expr]
        return Base.ccall_macro_lower((:ccall), Base.ccall_macro_parse(exprs)...)
    end
else
    function ccall_macro_lower(func, rettype, types, args, nreq)
        # instead of re-using ccall or Expr(:foreigncall) to perform argument conversion,
        # we need to do so ourselves in order to insert a jl_gc_safe_enter|leave
        # just around the inner ccall

        cconvert_exprs = []
        cconvert_args = []
        for (typ, arg) in zip(types, args)
            var = gensym("$(func)_cconvert")
            push!(cconvert_args, var)
            push!(cconvert_exprs, :($var = Base.cconvert($(esc(typ)), $(esc(arg)))))
        end

        unsafe_convert_exprs = []
        unsafe_convert_args = []
        for (typ, arg) in zip(types, cconvert_args)
            var = gensym("$(func)_unsafe_convert")
            push!(unsafe_convert_args, var)
            push!(unsafe_convert_exprs, :($var = Base.unsafe_convert($(esc(typ)), $arg)))
        end

        call = quote
            $(unsafe_convert_exprs...)

            gc_state = @ccall(jl_gc_safe_enter()::Int8)
            ret = ccall(
                $(esc(func)), $(esc(rettype)), $(Expr(:tuple, map(esc, types)...)),
                $(unsafe_convert_args...)
            )
            @ccall(jl_gc_safe_leave(gc_state::Int8)::Cvoid)
            ret
        end

        return quote
            @inline
            $(cconvert_exprs...)
            GC.@preserve $(cconvert_args...) $(call)
        end
    end

    macro gcsafe_ccall(expr)
        return ccall_macro_lower(Base.ccall_macro_parse(expr)...)
    end
end # HAS_CCALL_GCSAFE

using Test
using GPUToolbox
using InteractiveUtils
using IOCapture

@testset "GPUToolbox.jl" begin
    @testset "SimpleVersion" begin
        # Construct
        sv1 = SimpleVersion(42)
        @test sv1.major == 42
        @test sv1.minor == 0

        sv2 = SimpleVersion(42, 5)
        @test sv2.major == 42
        @test sv2.minor == 5

        sv3 = SimpleVersion("41")
        @test sv3.major == 41
        @test sv3.minor == 0

        sv4 = SimpleVersion("41.6")
        @test sv4.major == 41
        @test sv4.minor == 6

        sv5 = sv"43"
        @test sv5.major == 43
        @test sv5.minor == 0

        sv6 = sv"43.7"
        @test sv6.major == 43
        @test sv6.minor == 7

        @test_throws "invalid SimpleVersion string" SimpleVersion("42.5.0")
        @test_throws "invalid SimpleVersion string" SimpleVersion("bsrg")
        @test_throws "invalid SimpleVersion string" eval(:(sv"42.5.0"))
        @test_throws "invalid SimpleVersion string" eval(:(sv"bsrg"))

        # Comparison
        @test   sv3 < sv1  # (a.major < b.major)
        @test !(sv1 < sv3) # (a.major > b.major)
        @test   sv1 < sv2  # (a.minor < b.minor)
        @test !(sv4 < sv3) # (a.minor > b.minor)
        @test !(sv1 < sv1) # Default
        @test !(sv2 > sv2) # Default
    end

    @testset "Literals" begin
        @test 1i8 === Int8(1)
        @test 1i16 === Int16(1)
        @test 1i32 === Int32(1)
        @test_throws InexactError 128i8

        @test 1u8 === UInt8(1)
        @test 1u16 === UInt16(1)
        @test 1u32 === UInt32(1)
        @test_throws InexactError 256u8
    end

    @testset "gcsafe_ccall" begin
        function gc_safe_ccall()
            # jl_rand is marked as JL_NOTSAFEPOINT
            @gcsafe_ccall jl_rand()::UInt64
        end

        let llvm = sprint(code_llvm, gc_safe_ccall, ())
            # check that the call works
            @test gc_safe_ccall() isa UInt64
            # v1.10 is hard to test since ccall are just raw runtime pointers
            if VERSION >= v"1.11"
                if !GPUToolbox.HAS_CCALL_GCSAFE
                    # check for the gc_safe store
                    @test occursin("jl_gc_safe_enter", llvm)
                    @test occursin("jl_gc_safe_leave", llvm)
                else
                    @test occursin("store atomic i8 2", llvm)
                end
            end
        end
    end

    @testset "@enum_without_prefix" begin
        mod = @eval module $(gensym())
            using GPUToolbox
            @enum MY_ENUM MY_ENUM_VALUE
            @enum_without_prefix MY_ENUM MY_
        end

        @test mod.ENUM_VALUE == mod.MY_ENUM_VALUE

        # test with visibility=:export
        mod_export = @eval module $(gensym())
            using GPUToolbox
            @enum MY_ENUM MY_ENUM_A MY_ENUM_B
            @enum_without_prefix visibility=:export MY_ENUM MY_ENUM_
        end
        @test mod_export.A == mod_export.MY_ENUM_A
        @test mod_export.B == mod_export.MY_ENUM_B
        exported = names(mod_export)
        @test :A in exported
        @test :B in exported

        # test with visibility=:public
        @static if VERSION >= v"1.11"
            mod_public = @eval module $(gensym())
                using GPUToolbox
                @enum MY_ENUM MY_ENUM_P MY_ENUM_Q
                @enum_without_prefix visibility=:public MY_ENUM MY_ENUM_
            end
            @test mod_public.P == mod_public.MY_ENUM_P
            @test mod_public.Q == mod_public.MY_ENUM_Q
            # public but not exported
            @test :P in names(mod_public)
            @test !Base.isexported(mod_public, :P)
        end
    end

    @testset "LazyInitialized" begin
        # Basic functionality
        lazy = LazyInitialized{Int}()
        @test get!(lazy) do
            42
        end == 42

        # Should return same value on subsequent calls
        @test get!(lazy) do
            error("Should not be called")
        end == 42

        nothing_count = Ref(0)
        lazy_nothing = LazyInitialized{Union{Nothing,Int}}()
        @test get!(lazy_nothing) do
            nothing_count[] += 1
            nothing
        end === nothing
        @test nothing_count[] == 1
        @test get!(lazy_nothing) do
            error("Should not be called")
        end === nothing
        @test nothing_count[] == 1

    end

    @testset "LazyInitialized concurrency" begin
        init_count = Threads.Atomic{Int}(0)
        lazy = LazyInitialized{NTuple{4,Int}}()

        function build_tuple()
            id = Threads.atomic_add!(init_count, 1) + 1
            yield()
            return ntuple(Returns(id), 4)
        end

        tasks = [Threads.@spawn get!(build_tuple, lazy) for _ in 1:128]
        results = fetch.(tasks)
        @test init_count[] == 1
        @test all(==((1, 1, 1, 1)), results)
    end

    @testset "@memoize" begin
        # Test basic memoization without key
        call_count = Ref(0)
        function test_basic_memo()
            @memoize begin
                call_count[] += 1
                42
            end::Int
        end

        @test test_basic_memo() == 42
        @test call_count[] == 1
        @test test_basic_memo() == 42
        @test call_count[] == 1  # Should not increment

        nothing_call_count = Ref(0)
        function test_no_key_nothing_memo()
            @memoize begin
                nothing_call_count[] += 1
                nothing
            end::Union{Nothing,Int}
        end

        @test test_no_key_nothing_memo() === nothing
        @test nothing_call_count[] == 1
        @test test_no_key_nothing_memo() === nothing
        @test nothing_call_count[] == 1

        # Test memoization with key (dictionary)
        dict_call_count = Ref(0)
        function test_dict_memo(x)
            @memoize key=x::Int begin
                dict_call_count[] += 1
                x * 2
            end::Int
        end

        @test test_dict_memo(5) == 10
        @test dict_call_count[] == 1
        @test test_dict_memo(5) == 10
        @test dict_call_count[] == 1  # Should not increment
        @test test_dict_memo(3) == 6
        @test dict_call_count[] == 2  # Should increment for new key

        dict_nothing_call_count = Ref(0)
        function test_dict_nothing_memo(x)
            @memoize key=x::Int begin
                dict_nothing_call_count[] += 1
                nothing
            end::Union{Nothing,Int}
        end

        @test test_dict_nothing_memo(5) === nothing
        @test dict_nothing_call_count[] == 1
        @test test_dict_nothing_memo(5) === nothing
        @test dict_nothing_call_count[] == 1
        @test test_dict_nothing_memo(3) === nothing
        @test dict_nothing_call_count[] == 2

        # Test memoization with index (auto-growing array)
        index_call_count = Ref(0)
        function test_index_memo(x)
            @memoize index=x begin
                index_call_count[] += 1
                x * 3
            end::Int
        end

        @test test_index_memo(1) == 3
        @test index_call_count[] == 1
        @test test_index_memo(1) == 3
        @test index_call_count[] == 1  # Should not increment
        @test test_index_memo(2) == 6
        @test index_call_count[] == 2  # Should increment for new index

        index_nothing_call_count = Ref(0)
        function test_index_nothing_memo(x)
            @memoize index=x begin
                index_nothing_call_count[] += 1
                nothing
            end::Union{Nothing,Int}
        end

        @test test_index_nothing_memo(1) === nothing
        @test index_nothing_call_count[] == 1
        @test test_index_nothing_memo(1) === nothing
        @test index_nothing_call_count[] == 1
        @test test_index_nothing_memo(2) === nothing
        @test index_nothing_call_count[] == 2

        # `index` may come from APIs that return smaller integer types.
        int32_index_call_count = Ref(0)
        function test_index_memo_int32_index(x)
            @memoize index=x begin
                int32_index_call_count[] += 1
                Int(x) * 4
            end::Int
        end

        @test test_index_memo_int32_index(Int32(1)) == 4
        @test int32_index_call_count[] == 1
        @test test_index_memo_int32_index(Int32(1)) == 4
        @test int32_index_call_count[] == 1

        grow_counts = zeros(Int, 12)
        function test_index_grow(x)
            @memoize index=x begin
                grow_counts[x] += 1
                x + 100
            end::Int
        end

        @test [test_index_grow(i) for i in 1:12] == collect(101:112)
        @test [test_index_grow(i) for i in 1:12] == collect(101:112)
        @test all(==(1), grow_counts)

        bad_index_call_count = Ref(0)
        function test_bad_index_memo(x)
            @memoize index=x begin
                bad_index_call_count[] += 1
                x
            end::Int
        end

        @test_throws BoundsError test_bad_index_memo(0)
        @test_throws BoundsError test_bad_index_memo(-1)
        @test bad_index_call_count[] == 0

        @test_throws ArgumentError macroexpand(
            @__MODULE__, :(@memoize x::Int begin x end::Int)
        )
        @test_throws ArgumentError macroexpand(
            @__MODULE__, :(@memoize maxlen=2 begin 1 end::Int)
        )
    end

    @testset "@memoize concurrency" begin
        no_key_count = Threads.Atomic{Int}(0)
        function memo_no_key_stress()
            @memoize begin
                Threads.atomic_add!(no_key_count, 1)
                yield()
                1234
            end::Int
        end

        tasks = [Threads.@spawn memo_no_key_stress() for _ in 1:128]
        @test all(==(1234), fetch.(tasks))
        @test no_key_count[] == 1

        dict_count = Threads.Atomic{Int}(0)
        function memo_dict_stress(x)
            @memoize key=x::Int begin
                Threads.atomic_add!(dict_count, 1)
                yield()
                x * 10
            end::Int
        end

        keys = [mod1(i, 16) for i in 1:256]
        tasks = [Threads.@spawn memo_dict_stress(key) for key in keys]
        @test fetch.(tasks) == keys .* 10
        @test dict_count[] == 16

        index_count = Threads.Atomic{Int}(0)
        function memo_index_stress(x)
            @memoize index=x begin
                Threads.atomic_add!(index_count, 1)
                yield()
                x * 20
            end::Int
        end

        tasks = [Threads.@spawn memo_index_stress(key) for key in keys]
        @test fetch.(tasks) == keys .* 20
        @test index_count[] == 16

        index_count_after_warmup = index_count[]
        tasks = [Threads.@spawn memo_index_stress(key) for key in keys]
        @test fetch.(tasks) == keys .* 20
        @test index_count[] == index_count_after_warmup

        grow_race_count = Threads.Atomic{Int}(0)
        function memo_index_grow_race(x)
            @memoize index=x begin
                Threads.atomic_add!(grow_race_count, 1)
                yield()
                x * 30
            end::Int
        end

        @test memo_index_grow_race(1) == 30
        @test grow_race_count[] == 1
        tasks = [Threads.@spawn memo_index_grow_race(64) for _ in 1:128]
        @test all(==(64 * 30), fetch.(tasks))
        @test grow_race_count[] == 2
    end

    @testset "Session-safe caches" begin
        mktempdir() do dir
            probe_dir = joinpath(dir, "MemoSessionProbe")
            src_dir = joinpath(probe_dir, "src")
            mkpath(src_dir)

            write(joinpath(probe_dir, "Project.toml"), """
            name = "MemoSessionProbe"
            uuid = "5c47f73b-ac9c-4df8-9db3-37f1345bcb51"
            version = "0.1.0"

            [deps]
            Pkg = "44cfe95a-1eb2-52ea-b672-e2afdf69b78f"
            """)

            write(joinpath(src_dir, "MemoSessionProbe.jl"), """
            module MemoSessionProbe

            using GPUToolbox

            const PRECOMPILE = Ref((0, 0, 0, 0))
            const LAZY = LazyInitialized{Int}()

            lazy_pid() = get!(() -> Int(getpid()), LAZY)

            function memo_no_key_pid()
                @memoize begin
                    Int(getpid())
                end::Int
            end

            function memo_index_pid(key)
                @memoize index=key begin
                    Int(getpid())
                end::Int
            end

            function memo_dict_pid(key)
                @memoize key=key::Int begin
                    Int(getpid())
                end::Int
            end

            precompile_values() =
                (lazy_pid(), memo_no_key_pid(), memo_index_pid(1), memo_dict_pid(1))

            runtime_values() =
                (lazy_pid(), memo_no_key_pid(), memo_index_pid(1), memo_index_pid(4), memo_dict_pid(1))

            if ccall(:jl_generating_output, Cint, ()) != 0
                PRECOMPILE[] = precompile_values()
            end

            end
            """)

            julia = joinpath(Sys.BINDIR, Base.julia_exename())
            toolbox_path = pkgdir(GPUToolbox)
            setup = """
            using Pkg
            Pkg.develop(PackageSpec(path=$(repr(toolbox_path))))
            Pkg.instantiate()
            using MemoSessionProbe
            """
            run(Cmd([julia, "--startup-file=no", "--project=$probe_dir", "-e", setup]))

            check = """
            using MemoSessionProbe
            pre = MemoSessionProbe.PRECOMPILE[]
            vals = MemoSessionProbe.runtime_values()
            println("RESULT ", join((pre..., vals..., Int(getpid())), ","))
            """
            out = read(Cmd([julia, "--startup-file=no", "--project=$probe_dir", "-e", check]), String)
            line = only(filter(startswith("RESULT "), split(out, '\n')))
            nums = parse.(Int, split(chop(line; head=7, tail=0), ","))
            precompile_vals = nums[1:4]
            runtime_vals = nums[5:9]
            runtime_pid = nums[10]

            @test all(!=(0), precompile_vals)
            @test all(==(runtime_pid), runtime_vals)
            @test all(!=(runtime_pid), precompile_vals)
        end
    end

    @testset "@checked" begin
        # Test checked function generation
        check_called = Ref(false)
        check_result = Ref{Any}(nothing)

        check(f) = begin
            check_called[] = true
            result = f()
            check_result[] = result
            result == 0 ? nothing : error("Check failed with code $result")
        end

        @checked function test_checked_func(should_fail::Bool)
            should_fail ? 1 : 0
        end

        # Test successful case
        check_called[] = false
        @test test_checked_func(false) === nothing
        @test check_called[]
        @test check_result[] == 0

        # Test failure case
        check_called[] = false
        @test_throws "Check failed with code 1" test_checked_func(true)
        @test check_called[]
        @test check_result[] == 1

        # Test unchecked version
        @test unchecked_test_checked_func(false) == 0
        @test unchecked_test_checked_func(true) == 1
    end

    @testset "@debug_ccall" begin
        # Test that debug_ccall works and captures output
        c = IOCapture.capture() do
            @debug_ccall time()::Cint
        end

        @test c.value isa Cint
        @test occursin("time()", c.output)
        @test occursin("=", c.output)
    end
end

export @enum_without_prefix


## redeclare enum values without a prefix

# this is useful when enum values from an underlying C library, typically prefixed for the
# lack of namespacing in C, are to be used in Julia where we do have module namespacing.
macro enum_without_prefix(ex...)
    # destructure keyword arguments
    call = ex[end-1:end]
    kwargs = map(ex[1:end-2]) do kwarg
        if kwarg isa Symbol
            :($kwarg = $kwarg)
        elseif Meta.isexpr(kwarg, :(=))
            kwarg
        else
            throw(ArgumentError("Invalid keyword argument '$kwarg'"))
        end
    end

    visibility = nothing
    for kwarg in kwargs
        key, val = kwarg.args
        if key == :visibility
            val isa QuoteNode && (val = val.value)
            visibility = val::Symbol
        else
            throw(ArgumentError("Invalid keyword argument '$key'"))
        end
    end

    enum, prefix = call
    if isa(enum, Symbol)
        mod = __module__
    elseif Meta.isexpr(enum, :(.))
        mod = getfield(__module__, enum.args[1])
        enum = enum.args[2].value
    else
        error("Do not know how to refer to $enum")
    end
    enum = getfield(mod, enum)
    prefix = String(prefix)

    ex = quote end
    for instance in instances(enum)
        name = String(Symbol(instance))
        @assert startswith(name, prefix)
        short = Symbol(name[length(prefix)+1:end])
        push!(ex.args, :(const $short = $(mod).$(Symbol(name))))
        if visibility == :export
            push!(ex.args, :(export $short))
        elseif visibility == :public
            if VERSION >= v"1.11.0-DEV.469"
                push!(ex.args, Expr(:public, short))
            end
        end
    end

    return esc(ex)
end

export LazyInitialized

@inline generating_output() = ccall(:jl_generating_output, Cint, ()) != 0

const HAS_FIELD_REPLACE = isdefined(Base, :OncePerProcess)

@inline function wipe_on_serialize!(@nospecialize(obj), field::Symbol, @nospecialize(val))
    @static if HAS_FIELD_REPLACE
        ccall(:jl_set_precompile_field_replace, Cvoid, (Any, Any, Any), obj, field, val)
    end
    return
end

"""
    LazyInitialized{T}()

A thread-safe, lazily-initialized wrapper for a value of type `T`. Initialize and fetch the
value by calling `get!`. The constructor is ensured to only be called once.

This type is intended for lazy initialization of e.g. global structures, without using
`__init__`. It is similar to protecting accesses using a lock, but is much cheaper.

Any value of type `T`, including `nothing` when allowed by `T`, may be stored.

"""
mutable struct LazyInitialized{T}
    @atomic value::Union{Nothing,Some{T}}
    const lock::ReentrantLock
end

LazyInitialized{T}() where {T} = LazyInitialized{T}(nothing, ReentrantLock())

@inline function Base.get!(constructor::Base.Callable, x::LazyInitialized{T}) where {T}
    val = @atomic :acquire x.value
    val !== nothing && return Base.something(val)::T
    return slow_init!(constructor, x)::T
end

@noinline function slow_init!(constructor, x::LazyInitialized{T}) where {T}
    if generating_output() && !HAS_FIELD_REPLACE
        return constructor()::T
    end

    @lock x.lock begin
        val = @atomic :acquire x.value
        val !== nothing && return Base.something(val)::T
        result = constructor()::T
        generating_output() && wipe_on_serialize!(x, :value, nothing)
        @atomic :release x.value = Some{T}(result)
        return result
    end
end
